/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.5
        Device            :  PIC18F87K22
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include <stdio.h>

typedef enum {wait, taster0, taster1, taster2}stanje;
static bool flag2 = false;
static bool flag3 = false;
static bool flag4 = false;
static stanje tasteri;

bool debounce(uint8_t *port, uint8_t pin,uint16_t vreme, bool stanje)
{
    static bool flag = false;
    if((*port&(1<<pin)) == stanje<<pin)
    {
        flag = true;
        while(vreme--){
            __delay_ms(1);
        }
        
    }
    if((*port&(1<<pin)) == stanje<<pin && flag == true)
    {
        return true;
        flag = false;
    }
    else
        return false;
}

void check_buttons()
{
    
    if(debounce(&PORTB, 0, 5,true) && flag2)
        {
            tasteri = taster0;
            flag2 = false;
        }
    if(debounce(&PORTB, 0, 5, false))
        {
            flag2 = true;
        }
    
    if(debounce(&PORTB, 1, 5,true) && flag3)
        {
            tasteri = taster1;
            flag3 = false;
        }
    if(debounce(&PORTB, 1, 5, false))
        {
            flag3 = true;
        }
    if(debounce(&PORTB, 2, 5,true) && flag4)
        {
            tasteri = taster2;
            flag4 = false;
        }
    if(debounce(&PORTB, 2, 5, false))
        {
            flag4 = true;
        }
    
}

void main(void)
{
    // Initialize the device
    SYSTEM_Initialize();
    

    
    
    while (1)
    {
        
        
        switch(tasteri)
        {
            case wait : check_buttons(); break;
            case taster0 : printf("Pritisnut taster RB0\n"); tasteri = wait; break;
            case taster1 : printf("Pritisnut taster RB1\n");tasteri = wait; break;
            case taster2 : printf("Pritisnut taster RB2\n");tasteri = wait; break;
        }
        
    }
}
/**
 End of File
*/